searchNodes=[{"ref":"JWT.html","title":"JWT","type":"module","doc":"Encode claims for transmission as a JSON object that is used as the payload of a JSON Web Signature (JWS) structure, enabling the claims to be integrity protected with a Message Authentication Code (MAC), to be later verified see http://tools.ietf.org/html/rfc7519"},{"ref":"JWT.html#sign/2","title":"JWT.sign/2","type":"function","doc":"Return a JSON Web Token (JWT), a string representing a set of claims as a JSON object that is encoded in a JWS Example iex&gt; claims = %{iss: &quot;joe&quot;, exp: 1300819380, &quot;http://example.com/is_root&quot;: true} ...&gt; key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.sign(claims, key: key) &quot;eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJleHAiOjEzMDA4MTkzODAsImh0dHA6Ly9leGFtcGxlLmNvbS9pc19yb290Ijp0cnVlLCJpc3MiOiJqb2UifQ.C5kby-t7W1CM1VB_avPCCHbtOXsNsywYAKYex8rHZh8&quot; see http://tools.ietf.org/html/rfc7519#section-7.1"},{"ref":"JWT.html#unify_header/1","title":"JWT.unify_header/1","type":"function","doc":"Given an options map, return a map of header options Example iex&gt; JWT.unify_header(alg: &quot;RS256&quot;, key: &quot;key&quot;) %{typ: &quot;JWT&quot;, alg: &quot;RS256&quot;} Filters out unsupported claims options and ignores any encryption keys"},{"ref":"JWT.html#verify/2","title":"JWT.verify/2","type":"function","doc":"Return a tuple {:ok, claims (map)} if the JWT signature is verified, or {:error, &quot;invalid&quot;} otherwise Example iex&gt; jwt =&quot;eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJuYW1lIjoiam9lIiwiaHR0cDovL2V4YW1wbGUuY29tL2lzX3Jvb3QiOnRydWUsImRhdGV0aW1lIjoxMzAwODE5MzgwfQ.8CbXtOJ51MfPLlNTDpMMBHExFZGmqIC2c_hjuY0Dp24&quot; ...&gt; key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.verify(jwt, %{key: key}) {:ok, %{&quot;name&quot; =&gt; &quot;joe&quot;, &quot;datetime&quot; =&gt; 1300819380, &quot;http://example.com/is_root&quot; =&gt; true}} see http://tools.ietf.org/html/rfc7519#section-7.2"},{"ref":"JWT.html#verify!/2","title":"JWT.verify!/2","type":"function","doc":""},{"ref":"JWT.Algorithm.Ecdsa.html","title":"JWT.Algorithm.Ecdsa","type":"module","doc":"Sign or verify a JSON Web Signature (JWS) structure using EDCSA see http://tools.ietf.org/html/rfc7518#section-3.4"},{"ref":"JWT.Algorithm.Ecdsa.html#curve/1","title":"JWT.Algorithm.Ecdsa.curve/1","type":"function","doc":"Named curve corresponding to sha_bits"},{"ref":"JWT.Algorithm.Ecdsa.html#sign/3","title":"JWT.Algorithm.Ecdsa.sign/3","type":"function","doc":"Return a der-encoded digital signature, or Message Authentication Code (MAC) Example iex&gt; {_, private_key} = EcdsaUtil.key_pair ...&gt; der_encoded_mac = JWT.Algorithm.Ecdsa.sign(:sha256, private_key, &quot;signing_input&quot;) ...&gt; byte_size(der_encoded_mac) &gt; 69 true"},{"ref":"JWT.Algorithm.Ecdsa.html#verify?/4","title":"JWT.Algorithm.Ecdsa.verify?/4","type":"function","doc":"Predicate to verify a der-encoded digital signature, or Message Authentication Code (MAC) Example iex&gt; {public_key, private_key} = JWT.Algorithm.EcdsaUtil.key_pair ...&gt; mac = JWT.Algorithm.Ecdsa.sign(:sha256, private_key, &quot;signing_input&quot;) ...&gt; JWT.Algorithm.Ecdsa.verify?(mac, :sha256, public_key, &quot;signing_input&quot;) true"},{"ref":"JWT.Algorithm.EcdsaUtil.html","title":"JWT.Algorithm.EcdsaUtil","type":"module","doc":"Encryption keys for test"},{"ref":"JWT.Algorithm.EcdsaUtil.html#key_pair/1","title":"JWT.Algorithm.EcdsaUtil.key_pair/1","type":"function","doc":"Generate an Ecdsa {public_key, private_key} tuple"},{"ref":"JWT.Algorithm.Hmac.html","title":"JWT.Algorithm.Hmac","type":"module","doc":"Sign or verify a JSON Web Signature (JWS) structure using HMAC with SHA-2 algorithms see http://tools.ietf.org/html/rfc7518#section-3.2"},{"ref":"JWT.Algorithm.Hmac.html#sign/3","title":"JWT.Algorithm.Hmac.sign/3","type":"function","doc":"Return a Message Authentication Code (MAC) Example iex&gt; shared_key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.Algorithm.Hmac.sign(:sha256, shared_key, &quot;signing_input&quot;) &lt;&lt;90, 34, 44, 252, 147, 130, 167, 173, 86, 191, 247, 93, 94, 12, 200, 30, 173, 115, 248, 89, 246, 222, 4, 213, 119, 74, 70, 20, 231, 194, 104, 103&gt;&gt;"},{"ref":"JWT.Algorithm.Hmac.html#verify?/4","title":"JWT.Algorithm.Hmac.verify?/4","type":"function","doc":"Predicate to verify the signing_input by comparing a given mac to the mac for a newly signed message; comparison done in a constant-time manner to thwart timing attacks Example iex&gt; mac = &lt;&lt;90, 34, 44, 252, 147, 130, 167, 173, 86, 191, 247, 93, 94, 12, 200, 30, 173, 115, 248, 89, 246, 222, 4, 213, 119, 74, 70, 20, 231, 194, 104, 103&gt;&gt; ...&gt; shared_key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.Algorithm.Hmac.verify?(mac, :sha256, shared_key, &quot;signing_input&quot;) true"},{"ref":"JWT.Algorithm.Rsa.html","title":"JWT.Algorithm.Rsa","type":"module","doc":"Sign or verify a JSON Web Signature (JWS) structure using RSASSA-PKCS-v1_5 see http://tools.ietf.org/html/rfc7518#section-3.3"},{"ref":"JWT.Algorithm.Rsa.html#modulus/1","title":"JWT.Algorithm.Rsa.modulus/1","type":"function","doc":"RSA key modulus, n"},{"ref":"JWT.Algorithm.Rsa.html#sign/3","title":"JWT.Algorithm.Rsa.sign/3","type":"function","doc":"Return a Message Authentication Code (MAC) Example iex&gt; alias JWT.Algorithm.RsaUtil ...&gt; private_key = RsaUtil.private_key(&quot;test/fixtures/rsa&quot;, &quot;private_key.pem&quot;) ...&gt; mac = JWT.Algorithm.Rsa.sign(:sha256, private_key, &quot;signing_input&quot;) ...&gt; byte_size(mac) 256"},{"ref":"JWT.Algorithm.Rsa.html#verify?/4","title":"JWT.Algorithm.Rsa.verify?/4","type":"function","doc":"Predicate to verify a digital signature, or mac Example iex&gt; alias JWT.Algorithm.RsaUtil ...&gt; path_to_keys = &quot;test/fixtures/rsa&quot; ...&gt; private_key = RsaUtil.private_key(path_to_keys, &quot;private_key.pem&quot;) ...&gt; public_key = RsaUtil.public_key(path_to_keys, &quot;public_key.pem&quot;) ...&gt; mac = JWT.Algorithm.Rsa.sign(:sha256, private_key, &quot;signing_input&quot;) ...&gt; JWT.Algorithm.Rsa.verify?(mac, :sha256, public_key, &quot;signing_input&quot;) true"},{"ref":"JWT.Algorithm.RsaUtil.html","title":"JWT.Algorithm.RsaUtil","type":"module","doc":"Encryption keys for test"},{"ref":"JWT.Algorithm.RsaUtil.html#private_key/1","title":"JWT.Algorithm.RsaUtil.private_key/1","type":"function","doc":"Load an RSA private key from a string"},{"ref":"JWT.Algorithm.RsaUtil.html#private_key/2","title":"JWT.Algorithm.RsaUtil.private_key/2","type":"function","doc":"Load an RSA private key from a pem file"},{"ref":"JWT.Algorithm.RsaUtil.html#public_key/1","title":"JWT.Algorithm.RsaUtil.public_key/1","type":"function","doc":"Load an RSA public key from a string"},{"ref":"JWT.Algorithm.RsaUtil.html#public_key/2","title":"JWT.Algorithm.RsaUtil.public_key/2","type":"function","doc":"Load an RSA public key from a pem file"},{"ref":"JWT.Algorithm.SHA.html","title":"JWT.Algorithm.SHA","type":"module","doc":"Common algorithm sha_bits validation"},{"ref":"JWT.Algorithm.SHA.html#fetch_length!/1","title":"JWT.Algorithm.SHA.fetch_length!/1","type":"function","doc":""},{"ref":"JWT.Algorithm.SHA.html#valid?/1","title":"JWT.Algorithm.SHA.valid?/1","type":"macro","doc":""},{"ref":"JWT.Claim.html","title":"JWT.Claim","type":"module","doc":"Verify JSON Web Token (JWT) claims see http://tools.ietf.org/html/rfc7519#section-4.1"},{"ref":"JWT.Claim.html#verify/2","title":"JWT.Claim.verify/2","type":"function","doc":"Collect JWT claims that fail validation Example iex&gt; seconds = DateTime.to_unix(DateTime.utc_now) + 1 ...&gt; claims = %{&quot;exp&quot; =&gt; seconds} ...&gt; JWT.Claim.verify(claims, %{}) :ok iex&gt; claims = %{&quot;aud&quot; =&gt; &quot;Someone else&quot;} ...&gt; JWT.Claim.verify(claims, %{aud: &quot;You&quot;}) {:error, [aud: &quot;Someone else&quot;]} Returns a list containing any registered claims that fail validation"},{"ref":"JWT.Claim.Aud.html","title":"JWT.Claim.Aud","type":"module","doc":"Audience see http://tools.ietf.org/html/rfc7519#section-4.1.3"},{"ref":"JWT.Claim.Aud.html#reject?/2","title":"JWT.Claim.Aud.reject?/2","type":"function","doc":"Predicate to reject an audience claim value that does not include the recipient Example iex&gt; recipient = &quot;recipient&quot; ...&gt; aud = [recipient] ...&gt; Aud.reject?(aud, %{aud: recipient}) false Returns true or false"},{"ref":"JWT.Claim.Exp.html","title":"JWT.Claim.Exp","type":"module","doc":"Expiration time see http://tools.ietf.org/html/rfc7519#section-4.1.4"},{"ref":"JWT.Claim.Exp.html#reject?/2","title":"JWT.Claim.Exp.reject?/2","type":"function","doc":"Predicate to reject an expiration time claim value equal to or before the current time Example iex&gt; seconds = DateTime.to_unix(DateTime.utc_now) + 1 ...&gt; Exp.reject?(seconds, %{}) false Returns true if the current time is after numeric_date; otherwise returns false numeric_date is the number of seconds from the Unix Epoch (1970-01-01T00:00:00Z UTC) until the specified UTC date/time; non-integer values may be used"},{"ref":"JWT.Claim.Iat.html","title":"JWT.Claim.Iat","type":"module","doc":"Issued at see http://tools.ietf.org/html/rfc7519#section-4.1.6"},{"ref":"JWT.Claim.Iat.html#reject?/2","title":"JWT.Claim.Iat.reject?/2","type":"function","doc":"Predicate to reject an issued_at time claim value equal to or after the current time Example iex&gt; seconds = DateTime.to_unix(DateTime.utc_now) - 1 ...&gt; Iat.reject?(seconds, %{}) false Returns false if the current time is after numeric_date; otherwise returns true numeric_date is the number of seconds from the Unix Epoch (1970-01-01T00:00:00Z UTC) until the specified UTC date/time; non-integer values may be used"},{"ref":"JWT.Claim.Iss.html","title":"JWT.Claim.Iss","type":"module","doc":"Issuer see http://tools.ietf.org/html/rfc7519#section-4.1.1"},{"ref":"JWT.Claim.Iss.html#reject?/2","title":"JWT.Claim.Iss.reject?/2","type":"function","doc":"Predicate to reject an iss claim that does not match the expected issuer Example iex&gt; Iss.reject?(&quot;issuer&quot;, %{iss: &quot;other issuer&quot;}) true Returns true or false"},{"ref":"JWT.Claim.Jti.html","title":"JWT.Claim.Jti","type":"module","doc":"JWT ID see http://tools.ietf.org/html/rfc7519#section-4.1.7"},{"ref":"JWT.Claim.Jti.html#reject?/2","title":"JWT.Claim.Jti.reject?/2","type":"function","doc":"Predicate to reject a jti claim that does not match the expected JTI Example iex&gt; Jti.reject?(&quot;jwt_id&quot;, %{iss: &quot;other jwt_id&quot;}) true Returns true or false"},{"ref":"JWT.Claim.Nbf.html","title":"JWT.Claim.Nbf","type":"module","doc":"Not before see http://tools.ietf.org/html/rfc7519#section-4.1.5"},{"ref":"JWT.Claim.Nbf.html#reject?/2","title":"JWT.Claim.Nbf.reject?/2","type":"function","doc":"Predicate to reject an expiration time claim value equal to or before the current time Example iex&gt; seconds = DateTime.to_unix(DateTime.utc_now) - 1 ...&gt; Nbf.reject?(seconds, %{}) false Returns true if the current time is before numeric_date; otherwise returns false numeric_date is the number of seconds from the Unix Epoch (1970-01-01T00:00:00Z UTC) until the specified UTC date/time; non-integer values may be used"},{"ref":"JWT.ClaimValidationError.html","title":"JWT.ClaimValidationError","type":"exception","doc":""},{"ref":"JWT.Coding.html","title":"JWT.Coding","type":"module","doc":""},{"ref":"JWT.Coding.html#decode/2","title":"JWT.Coding.decode/2","type":"function","doc":""},{"ref":"JWT.Coding.html#decode!/2","title":"JWT.Coding.decode!/2","type":"function","doc":""},{"ref":"JWT.Coding.html#encode!/1","title":"JWT.Coding.encode!/1","type":"function","doc":""},{"ref":"JWT.InvalidSignatureError.html","title":"JWT.InvalidSignatureError","type":"exception","doc":""},{"ref":"JWT.Jwa.html","title":"JWT.Jwa","type":"module","doc":"Choose a cryptographic algorithm to be used for a JSON Web Signature (JWS) see http://tools.ietf.org/html/rfc7518"},{"ref":"JWT.Jwa.html#destructured_alg/1","title":"JWT.Jwa.destructured_alg/1","type":"function","doc":"Return a tuple with a valid encryption module and sha_bits; raise if string is not a supported algorithm Example iex&gt; JWT.Jwa.destructured_alg(&quot;HS256&quot;) {JWT.Algorithm.Hmac, :sha256}"},{"ref":"JWT.Jwa.html#sign/3","title":"JWT.Jwa.sign/3","type":"function","doc":"Return a Message Authentication Code (MAC) for a particular algorithm Example iex&gt; key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.Jwa.sign(&quot;HS256&quot;, key, &quot;signing_input&quot;) &lt;&lt;90, 34, 44, 252, 147, 130, 167, 173, 86, 191, 247, 93, 94, 12, 200, 30, 173, 115, 248, 89, 246, 222, 4, 213, 119, 74, 70, 20, 231, 194, 104, 103&gt;&gt;"},{"ref":"JWT.Jwa.html#verify?/4","title":"JWT.Jwa.verify?/4","type":"function","doc":"Predicate to validate that mac does verify by algorithm Example iex&gt; mac = &lt;&lt;90, 34, 44, 252, 147, 130, 167, 173, 86, 191, 247, 93, 94, 12, 200, 30, 173, 115, 248, 89, 246, 222, 4, 213, 119, 74, 70, 20, 231, 194, 104, 103&gt;&gt; ...&gt; key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.Jwa.verify?(mac, &quot;HS256&quot;, key, &quot;signing_input&quot;) true"},{"ref":"JWT.Jws.html","title":"JWT.Jws","type":"module","doc":"Represent content to be secured with digital signatures or Message Authentication Codes (MACs) see http://tools.ietf.org/html/rfc7515"},{"ref":"JWT.Jws.html#sign/3","title":"JWT.Jws.sign/3","type":"function","doc":"Return a JSON Web Signature (JWS), a string representing a digitally signed payload Example iex&gt; key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.Jws.sign(%{alg: &quot;HS256&quot;}, &quot;payload&quot;, key) &quot;eyJhbGciOiJIUzI1NiJ9.cGF5bG9hZA.uVTaOdyzp_f4mT_hfzU8LnCzdmlVC4t2itHDEYUZym4&quot;"},{"ref":"JWT.Jws.html#unsecured_message/2","title":"JWT.Jws.unsecured_message/2","type":"function","doc":"Return a JWS that provides no integrity protection (i.e. lacks a signature) Example iex&gt; JWT.Jws.unsecured_message(%{alg: &quot;none&quot;}, &quot;payload&quot;) &quot;eyJhbGciOiJub25lIn0.cGF5bG9hZA.&quot; see http://tools.ietf.org/html/rfc7515#page-47"},{"ref":"JWT.Jws.html#verify/3","title":"JWT.Jws.verify/3","type":"function","doc":"Return a tuple {:ok, jws (string)} if the signature is verified, or {:error, &quot;invalid&quot;} otherwise Example iex&gt; jws = &quot;eyJhbGciOiJIUzI1NiJ9.cGF5bG9hZA.uVTaOdyzp_f4mT_hfzU8LnCzdmlVC4t2itHDEYUZym4&quot; ...&gt; key = &quot;gZH75aKtMN3Yj0iPS4hcgUuTwjAzZr9C&quot; ...&gt; JWT.Jws.verify(jws, &quot;HS256&quot;, key) {:ok, [&quot;eyJhbGciOiJIUzI1NiJ9&quot;, &quot;cGF5bG9hZA&quot;, &quot;uVTaOdyzp_f4mT_hfzU8LnCzdmlVC4t2itHDEYUZym4&quot;]}"},{"ref":"JWT.Jws.html#verify!/3","title":"JWT.Jws.verify!/3","type":"function","doc":""},{"ref":"JWT.MissingKeyError.html","title":"JWT.MissingKeyError","type":"exception","doc":""},{"ref":"JWT.SecurityError.html","title":"JWT.SecurityError","type":"exception","doc":""},{"ref":"JWT.UnmatchedAlgorithmError.html","title":"JWT.UnmatchedAlgorithmError","type":"exception","doc":""}]